#
# libbitree.rb by 2003.6/23 by tokuhisa
#

class BiTreeNode
  def initialize(data)
    @data = data
    @ltlink = nil
    @gelink = nil
  end

  attr_accessor :data
  attr_accessor :ltlink
  attr_accessor :gelink

  def insert(data)
    if @data > data then
      if @ltlink == nil then
        @ltlink = BiTreeNode.new(data)
      else
        @ltlink.insert(data)
      end
    else
      if @gelink == nil then
	@gelink = BiTreeNode.new(data)
      else
	@gelink.insert(data)
      end
    end
  end

  def to_a
    if @ltlink != nil then
      ans = @ltlink.to_a
    else
      ans = []
    end
    ans += [@data]
    if @gelink != nil then
      ans += @gelink.to_a
    end
    return ans
  end

  def to_a_rev
    if @gelink != nil then
      ans = @gelink.to_a_rev
    else
      ans = []
    end
    ans += [@data]
    if @ltlink != nil then
      ans += @ltlink.to_a_rev
    end
    return ans
  end

end

class BiTree
  def initialize
    @size = 0
    @root = nil
  end

  def set(data)
    @size += 1
    if @root == nil then
      @root = BiTreeNode.new(data)
    else
      @root.insert(data)
    end
  end

  def to_a
    if @root == nil then
      return []
    else
      return @root.to_a
    end
  end

  def to_a_rev
    if @root == nil then
      return []
    else
      return @root.to_a_rev
    end
  end

end